Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents mnuFile As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Friend WithEvents dlgOpenFile As System.Windows.Forms.OpenFileDialog
    Friend WithEvents rchFile As System.Windows.Forms.RichTextBox
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileSaveAs As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileSave As System.Windows.Forms.MenuItem
    Friend WithEvents dlgSaveFile As System.Windows.Forms.SaveFileDialog
    Friend WithEvents mnuFileNew As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.mnuFile = New System.Windows.Forms.MenuItem
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem
        Me.mnuFileSave = New System.Windows.Forms.MenuItem
        Me.mnuFileSaveAs = New System.Windows.Forms.MenuItem
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.mnuFileExit = New System.Windows.Forms.MenuItem
        Me.dlgOpenFile = New System.Windows.Forms.OpenFileDialog
        Me.rchFile = New System.Windows.Forms.RichTextBox
        Me.dlgSaveFile = New System.Windows.Forms.SaveFileDialog
        Me.mnuFileNew = New System.Windows.Forms.MenuItem
        Me.SuspendLayout()
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile})
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileNew, Me.mnuFileOpen, Me.mnuFileSave, Me.mnuFileSaveAs, Me.MenuItem1, Me.mnuFileExit})
        Me.mnuFile.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 1
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open"
        '
        'mnuFileSave
        '
        Me.mnuFileSave.Enabled = False
        Me.mnuFileSave.Index = 2
        Me.mnuFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS
        Me.mnuFileSave.Text = "&Save"
        '
        'mnuFileSaveAs
        '
        Me.mnuFileSaveAs.Enabled = False
        Me.mnuFileSaveAs.Index = 3
        Me.mnuFileSaveAs.Shortcut = System.Windows.Forms.Shortcut.CtrlA
        Me.mnuFileSaveAs.Text = "Save &As..."
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 4
        Me.MenuItem1.Text = "-"
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 5
        Me.mnuFileExit.Text = "E&xit"
        '
        'dlgOpenFile
        '
        Me.dlgOpenFile.Filter = "Text Files|*.txt|All Files|*.*"
        Me.dlgOpenFile.FilterIndex = 2
        '
        'rchFile
        '
        Me.rchFile.Dock = System.Windows.Forms.DockStyle.Fill
        Me.rchFile.Location = New System.Drawing.Point(0, 0)
        Me.rchFile.Name = "rchFile"
        Me.rchFile.Size = New System.Drawing.Size(292, 273)
        Me.rchFile.TabIndex = 0
        Me.rchFile.Text = ""
        '
        'mnuFileNew
        '
        Me.mnuFileNew.Index = 0
        Me.mnuFileNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN
        Me.mnuFileNew.Text = "&New"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.Add(Me.rchFile)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "MruEdit []"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Const APP_NAME As String = "MruEdit"
    Private m_DataDirty As Boolean
    Private m_FileName As String
    Private WithEvents m_MruList As MruList

    ' Set the dialog's initial directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim init_dir As String = Application.StartupPath
        If init_dir.EndsWith("\bin") Then init_dir = init_dir.Substring(0, init_dir.Length - 4)
        dlgOpenFile.InitialDirectory = init_dir
        dlgSaveFile.InitialDirectory = init_dir

        m_MruList = New MruList(APP_NAME, mnuFile, 4)
    End Sub

    ' Open a file.
    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        ' Make sure the current data is safe.
        If Not DataSafe() Then Exit Sub

        If dlgOpenFile.ShowDialog() = DialogResult.OK Then
            LoadData(dlgOpenFile.FileName)
        End If
    End Sub

    ' Return True if it is safe to discard the current data.
    Private Function DataSafe() As Boolean
        If Not m_DataDirty Then Return True

        Select Case MessageBox.Show( _
                "The data has been modified. Do you want to save the changes?", _
                "Save Changes?", MessageBoxButtons.YesNoCancel)
            Case DialogResult.Cancel
                ' The user is canceling the operation. 
                ' Don't discard the changes.
                Return False
            Case DialogResult.No
                ' The user wants to discard the changes.
                Return True
            Case DialogResult.Yes
                ' Try to save the data.
                SaveData(m_FileName)

                ' See if the data was saved.
                Return (Not m_DataDirty)
        End Select
    End Function

    ' Load a data file.
    Private Sub LoadData(ByVal file_name As String)
        Dim stream_reader As IO.StreamReader
        Try
            ' Load the file.
            stream_reader = New IO.StreamReader(file_name)
            Dim txt As String = stream_reader.ReadToEnd()
            rchFile.Text = txt

            ' Save the file name and title.
            m_FileName = file_name
            Me.Text = APP_NAME & " [" & FileTitle(m_FileName) & "]"
            m_DataDirty = False

            ' Update the MRU list.
            m_MruList.Add(m_FileName)
            mnuFileSave.Enabled = False
            mnuFileSaveAs.Enabled = False
        Catch ex As Exception
            MessageBox.Show("Error loading file " & file_name & _
                vbCrLf & ex.Message, _
                "Load Error", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Error)
            m_MruList.Remove(file_name)
        Finally
            If Not (stream_reader Is Nothing) Then stream_reader.Close()
        End Try
    End Sub

    ' Save the file.
    Private Sub SaveData(ByVal file_name As String)
        Dim stream_writer As IO.StreamWriter
        Try
            ' Save the file.
            stream_writer = New IO.StreamWriter(file_name)
            stream_writer.Write(Me.rchFile.Text)
            stream_writer.Close()

            ' Save the file name and title.
            m_FileName = file_name
            Me.Text = APP_NAME & " [" & FileTitle(file_name) & "]"
            m_DataDirty = False

            ' Update the MRU list.
            m_MruList.Add(m_FileName)
            Me.mnuFileSave.Enabled = False
            Me.mnuFileSaveAs.Enabled = False
        Catch ex As Exception
            MessageBox.Show("Error saving file " & file_name & _
                vbCrLf & ex.Message, _
                "Save Error", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Error)
        End Try
    End Sub

    ' Mark the data as modified.
    Private Sub rchFile_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rchFile.TextChanged
        If Not m_DataDirty Then
            Me.Text = APP_NAME & "*[" & FileTitle(m_FileName) & "]"
            m_DataDirty = True
            mnuFileSave.Enabled = True
            mnuFileSaveAs.Enabled = True
        End If
    End Sub

    ' Open a file selected from the MRU list.
    Private Sub m_MruList_OpenFile(ByVal file_name As String) Handles m_MruList.OpenFile
        LoadData(file_name)
    End Sub

    ' Save the file.
    Private Sub mnuFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSave.Click
        If m_FileName Is Nothing Then
            mnuFileSaveAs_Click(sender, e)
        Else
            SaveData(m_FileName)
        End If
    End Sub

    ' Save the file with a new name.
    Private Sub mnuFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSaveAs.Click
        dlgSaveFile.FileName = dlgOpenFile.FileName
        If dlgSaveFile.ShowDialog() = DialogResult.OK Then
            SaveData(dlgSaveFile.FileName)
        End If
    End Sub

    ' Close the application.
    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

    ' Don't close if the data's not safe.
    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        e.Cancel = Not DataSafe()
    End Sub

    ' Start a new document.
    Private Sub mnuFileNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileNew.Click
        ' Make sure the current data is safe.
        If Not DataSafe() Then Exit Sub

        Me.rchFile.Text = ""
        m_FileName = Nothing
        Me.Text = APP_NAME & " []"
        m_DataDirty = False

        ' No point in saving a blank file.
        Me.mnuFileSave.Enabled = False
        Me.mnuFileSaveAs.Enabled = False
    End Sub
End Class
